/*
	Some parts of this code come from xmatrix for gba from "Adam"
	already taken from the screensaver xmatrix by Jamie Zawinski (true)
	etc ... already taken from .... and from ...
	and finaly from my fisrt cpc 6128 Asm routines  (false these old
	routines will be used in future OS W6000in a few century)
	:-D 
*/

#include "cossin.h"	// Precalculated Cos / Sin tables.
#include "bg.h"		// Background texture

typedef unsigned short int uint16;
typedef unsigned int uint;
typedef unsigned char bool;

#define TRUE (0 == 0)
#define FALSE (0 == 1)
#define VRAM        0x06000000
#define BCK_M5_VRAM 0x0600A000
#define PAL	    0x05000000
#define REG_BG0CNT  0x04000008
#define REG_BG1CNT  0x0400000a
#define REG_BLDCNT  0x04000050
#define REG_BLDY    0x04000054
#define REG_JP      0x04000130
#define REG_DISPCNT *(uint16*)0x04000000
#define SetMode(Mode) REG_DISPCNT=(Mode)
#define MODE_3	    0x03	//   240*160 15bits
#define MODE_4	    0x04	//   240*160 8bits indexed palette
#define MODE_5	    0x05	//   160*128 15bits :-O	
#define BACKBUFFER  0x010	
#define BG2_ENABLE  0x0400
#define RGB(r,g,b) ((r)+((g)<<5)+((b)<<10))

void waitretrace(void);
void WaitVBlank (void);
uint16 jp_getstate(void);
void Copy32 (int *src,int *dst,unsigned int nb);
void Clear32 (int *src,unsigned int nb);
void SwapScreen (void);
int abs (int value);
void SendPal (short *pal);
void M4_PutPixel (int x,int y, unsigned char color);
void Zoom ();
uint16 *ActualVideoBuffer;
unsigned int _rsa = 0x76237;
unsigned int _rsb = 0x1;
unsigned int random(void);
short Pal [256];
void M4_DrawSprite(int x,int y,int w,int h,char *src);

unsigned short ScreenBuffer [120*160];

int main()
{
int i,x1,y1,x2,y2,alpha0;

SetMode (MODE_4 | BG2_ENABLE);
ActualVideoBuffer = (uint16*)0x600A000;// BCK_M5_VRAM;


for (i=0;i<256;i++)
  {
  Pal [i] = (((cmap [i][0])>>3) | ((cmap [i][1]>>3)<<5) | ((cmap [i][2]>>3)<<10));
  }

SendPal (Pal);

alpha0 =0;
x2=30;
y2=4;

while (1) 
  {
  Zoom ();  
  x1 = 90+ ((20 * Cos [alpha0])>>7); 
  y1 = 50+ ((20 * Sin [alpha0])>>7);
  alpha0 -=8;
  if (alpha0<1) alpha0 =359;
  x2 += y2;
  if ((x2<6) || (x2>170)) y2 *= -1;
  M4_DrawSprite (x1,y1,60,60,&bg[x2]);
  Copy32 ((int *)ActualVideoBuffer,(int *)ScreenBuffer,9600); 
  WaitVBlank();
  SwapScreen ();
  }
  return(0);
}




void Zoom ()
{
int i,o;
unsigned int src,ssrc,dst;
unsigned int dtx,dty;

dtx=0;
dty=0;
ssrc =15+(20*120);
src=ssrc;
dst=0;
for (o=0;o<160;o++)
  {
  for (i=0;i<120;i++)
    {
    ActualVideoBuffer [dst] = ScreenBuffer [src+(dtx>>8)];
    dst++;
    dtx+=192;
    }
  dty+=192;
  dtx=0;
  src = ssrc + (120*(dty>>8));
  }
}






/* returns joypad state */
uint16 jp_getstate(void)
{
  return(~*((uint16 *)REG_JP));
}

void waitretrace(void)
{
  while(!((*((volatile uint16 *)0x04000004) & (1<<0))));
  return;
}

void Copy32 (int *src,int *dst,unsigned int nb)
{
unsigned int i=0;

for (i=0;i<nb;i++)
  {
  *dst= *src;
  dst++;
  src++;
  }
}

void Clear32 (int *src,unsigned int nb)
{
unsigned int i=0;

for (i=0;i<nb;i++)
  {
  *src=0;
  src++;
  }
}



int abs (int value)
{
if (value <0) return (value* -1);
else return (value);
}

void SwapScreen ()
{
if (REG_DISPCNT & BACKBUFFER)
  {
  
  REG_DISPCNT &= ~BACKBUFFER;
  ActualVideoBuffer = (uint16*) BCK_M5_VRAM;
  }
else
  {
  
  REG_DISPCNT |= BACKBUFFER;
  ActualVideoBuffer = (uint16*) VRAM;
  }
}

void WaitVBlank (void)
{
while (*(volatile uint16*)0x4000006<160) {};
}

void SendPal (short *pal)
{
int i;
short  *PalPtr=(short *)PAL;

for (i=0;i<256;i++)
  PalPtr [i] = pal [i];  
}

/*   
    With this we can plot in (240*160) resolution.
*/
void M4_PutPixel (int x,int y, unsigned char color)
{
short col;
unsigned int dst;

dst = (y*120)+(x>>1);
col = ActualVideoBuffer [dst];
if (x & 1)	// impair value
  {
  col &=0xff;
  col |= (color<<8);  
  }
else
  {
  col &=0xff00;
  col |= color;
  }
ActualVideoBuffer[dst] = col;
}

void M4_DrawSprite(int x,int y,int w,int h,char *src)
{
int i,o;
int nl;

nl = 240-w;
for (o=0;o<h;o++)
  {
  for (i=0;i<w;i++)
    {
    M4_PutPixel (x+i,y+o,*src);
    src++;
    }
  src+=nl;
  }
}

#ifdef __GNUC__
static void __gccmain() { }
#endif
